Boomkinator = LibStub("AceAddon-3.0"):NewAddon("Boomkinator", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local L    = LibStub("AceLocale-3.0"):GetLocale("Boomkinator")

local settings
local UnitBuff = _G.UnitBuff
local UnitDebuff = _G.UnitDebuff
local GetSpellInfo = _G.GetSpellInfo
local GetSpellCooldown= _G.GetSpellCooldown
local sformat = string.format

local updater = ""

local buttons = {}
local timers = {}
local stacks = {}
local ccount

local bLastCycle = 0
local wreak = 0

Boomkinator.Credits1 = "Boomkinator - by Aznamir (Lightbringer US)";

-------------------------------------------------------------------
-- Spell Settings
-------------------------------------------------------------------
Boomkinator.OwlSpells = {
    -- DoTs
	[1] = GetSpellInfo(8921),   -- Moonfire
    [2] = GetSpellInfo(93402),  -- Sunfire
	-- generators
	[3] = GetSpellInfo(194153),   -- Lunar Strike
	[4] = GetSpellInfo(5176),   -- Solar Wrath
	
	-- spenders
	[5] = GetSpellInfo(78674),  -- Starsurge
	[6] = GetSpellInfo(50288),  -- Starfall
	-- artifact
	[7] = GetSpellInfo(202767), -- new moon
	-- buffs
	[8] = GetSpellInfo(194223), -- Celestial Alignment
	[9] = nil,
	[12] = GetSpellInfo(164547), -- lunar empowerment
	[13] = GetSpellInfo(164545), -- solar empowerment
	--
	[14] = nil,  -- stellar flare
	--
}
Boomkinator.CatSpells = {
	[1] = GetSpellInfo(5221), -- shred
	[2] = GetSpellInfo(1079), -- rip
	[3] = GetSpellInfo(16974), -- predatory swiftness
	[4] = GetSpellInfo(1822), -- rake	
	[5] = GetSpellInfo(52610), -- savage roar
	[6] = GetSpellInfo(50334), -- berserk
	[7] = GetSpellInfo(5217), -- tiger's fury
}
Boomkinator.BearSpells = {
	[1] = GetSpellInfo(77758), -- thrash
	[2] = GetSpellInfo(33745), -- lacerate
	[3] = GetSpellInfo(770), -- faerie fire
	[4] = GetSpellInfo(33878), -- mangle
	[5] = GetSpellInfo(61336), -- surv instinct
	[6] = GetSpellInfo(106952), -- berserk
	[7] = GetSpellInfo(22812), -- barkskin
	[8] = GetSpellInfo(62606), -- savage defense
}
Boomkinator.SurvivalSpells = {
	[1] = GetSpellInfo(53301), -- Explosive Shot
	[2] = GetSpellInfo(3674), -- Black Arrow
	[3] = GetSpellInfo(1978), -- Serpent Sting
	[4] = GetSpellInfo(53351), -- Kill Shot
}
Boomkinator.BeastSpells = {
	[1] = GetSpellInfo(34026), 	-- kill command cooldown
	[2] = GetSpellInfo(120679),	-- dire beast coodown
	[3] = GetSpellInfo(120697),	-- lynx rush cooldown
	[4] = GetSpellInfo(19574),	-- bestial wrath cooldown
	[5] = GetSpellInfo(3045),	-- rapid fire
}
Boomkinator.WindwalkerSpells = {
	[1] = GetSpellInfo(125359), -- tiger power
	[2] = GetSpellInfo(118864), -- combo breaker: tiger palm
	[3] = GetSpellInfo(116768), -- combo breaker: blackout kick
	[4] = GetSpellInfo(125195), -- tigereyebrew
	[5] = GetSpellInfo(117418), -- fists of fury
	[6] = GetSpellInfo(107428), -- rising sun kick
}
Boomkinator.CombatSpells = {
	[1] = GetSpellInfo(196937), 	-- ghostly-strike
	[2] = GetSpellInfo(5171), 		-- #5 slice and dice
	[3] = GetSpellInfo(13750),		-- #8 adrenaline rush,
	[4] = GetSpellInfo(195627),  	--opportunity
	[5] = GetSpellInfo(212198),   	--crimson-vial
	[6] = GetSpellInfo(199804),		--between-the-eyes
	[7] = GetSpellInfo(1766), 		-- kick
}
Boomkinator.DemoSpells = {
	[1] = GetSpellInfo(603), -- doom
	[2] = GetSpellInfo(104316), -- call dreadstalkers
	[3] = GetSpellInfo(193396), -- demonic empowerment
	[4] = GetSpellInfo(211717), -- artifact
	[5] = GetSpellInfo(18540), -- Doomguard
	[6] = GetSpellInfo(205145), -- demonic calling
}
Boomkinator.AffSpells = {
	[1] = GetSpellInfo(980), --131737), 	-- agony
	[2] = GetSpellInfo(172), 		-- corruption
	[3] = GetSpellInfo(30108), --131736), 	-- unstable affliction
	[4] = GetSpellInfo(63106), -- siphon life
	[5] = GetSpellInfo(48181), 		-- haunt
	[6] = GetSpellInfo(18540), 		-- doomguard
	[7] = GetSpellInfo(111859), 	-- grimoire
}
Boomkinator.DestSpells = {
	[1] = GetSpellInfo(348),		-- immolate
	[2] = GetSpellInfo(17962),		-- conflagrate
	[3] = GetSpellInfo(224322),		-- demonfire
	[4] = GetSpellInfo(196586), 	-- artifact dimensional rift
	[6] = GetSpellInfo(18540), 		-- doomguard
	[7] = GetSpellInfo(111859), 	-- grimoire
	[9] = GetSpellInfo(80240),		-- havoc
	[10] = GetSpellInfo(104773),	-- resolve
	[11] = GetSpellInfo(196414),  -- eradication
}
Boomkinator.ShadowSpells = {
	[1] = GetSpellInfo(589), 	    -- Shadow Word: Pain
	[2] = GetSpellInfo(34914), 	    -- Vampiric Touch1
	[3] = GetSpellInfo(8092),		-- mind blast
	[4] = GetSpellInfo(2944), 		-- Devouring Plague
	[5] = GetSpellInfo(87160),		-- Surge of Darkness
	[6] = GetSpellInfo(32379),		-- Shadow Word: Death
}
Boomkinator.AssassinationSpells = {
	[1] = GetSpellInfo(1329), -- mutilate
	[2] = GetSpellInfo(111240), -- dispatch
	[3] = GetSpellInfo(32645), -- envenom
	[4] = GetSpellInfo(79140), -- vendetta
	[5] = GetSpellInfo(1943), -- rupture
	[6] = GetSpellInfo(121152), -- blindside
	[7] = GetSpellInfo(114015), -- anticipation
}
Boomkinator.Icons = {
	["Owl"] = {
		[1] = "Interface\\Icons\\spell_nature_starfall", -- moonfire (button 1)
		[2] = "", --Interface\\Icons\\Ability_Druid_Starfall", -- starfall (button 2)		
		[3] = "Interface\\Icons\\Ability_Mage_FireStarter", -- sunfire (button 3)
		[4] = "Interface\\Icons\\Spell_Arcane_StarFire", -- lunar strike (button 4)
		[5] = "Interface\\Icons\\Spell_Arcane_Arcane03", -- lunar strike (button 5)
		[6] = "Interface\\Icons\\spell_nature_wrathv2", -- star surge (button 6)
		[7] = "Interface\\Icons\\Ability_Druid_Starfall", --Interface\\Icons\\Ability_Druid_ForceofNature", -- treants (button 7)
		[8] = "Interface\\Icons\\Spell_Nature_NatureGuardian", -- celestial alignment (button 8)
		[9] = "Interface\\Icons\\artifactability_balancedruid_newmoon", -- artifact
		[10] = "Interface\\Icons\\artifactability_balancedruid_halfmoon",
		[11] = "Interface\\Icons\\artifactability_balancedruid_fullmoon",
		[12] = "Interface\\Icons\\Spell_Nature_NatureGuardian"
	},
	["Cat"] = {
		[1] = "Interface\\Icons\\Spell_Shadow_VampiricAura",
		[2] = "Interface\\Icons\\Ability_GhoulFrenzy",
		[3] = "Interface\\Icons\\Ability_Hunter_Pet_Cat", -- predatory swiftness
		[4] = "Interface\\Icons\\Ability_Druid_SkinTeeth",
		[5] = "Interface\\Icons\\Ability_Druid_Disembowel",
		[6] = "Interface\\Icons\\Ability_Mount_JungleTiger",
		[7] = "Interface\\Icons\\Ability_Druid_Berserk",
		[8] = "",
		[9] = "",
--		[10] = "",
	},
	["Bear"] = {
		[1] = "Interface\\Icons\\Spell_Druid_Thrash", -- thrash
		[2] = "Interface\\Icons\\Ability_Druid_Lacerate", -- lacerate
		[3] = "Interface\\Icons\\Spell_Nature_FaerieFire",  -- faerie fire		
		[4] = "Interface\\Icons\\Ability_Druid_Mangle2", -- mangle
		[5] = "Interface\\Icons\\Ability_Druid_TigersRoar", -- survival instincts
		[6] = "Interface\\Icons\\Ability_Druid_Berserk", -- berserk
		[7] = "Interface\\Icons\\Spell_Nature_StoneClawTotem", -- barkskin
		[8] = "Interface\\Icons\\Ability_Racial_Cannibalize", -- savage defense
		[9] = "",
	},
	["HunterSurvival"] = {
		[1] = "Interface\\Icons\\Ability_Hunter_ExplosiveShot", -- kill command
		[2] = "Interface\\Icons\\Spell_Shadow_PainSpike", -- dire beast
		[3] = "", -- lynx rush
		[4] = "Interface\\Icons\\Ability_Hunter_Quickshot", -- bestial wrath
		[5] = "Interface\\Icons\\Ability_Hunter_Assassinate2", -- rapid fire
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
--		[10] = "",		
	},
	["HunterBeast"] = {
		[1] = "Interface\\Icons\\Ability_Hunter_KillCommand",
		[2] = "INTERFACE\\ICONS\\ability_hunter_sickem", -- dire beast
		[3] = "Interface\\Icons\\Ability_Hunter_CatlikeReflexes", -- lynx rush
		[4] = "Interface\\Icons\\Ability_Druid_FerociousBite",
		[5] = "Interface\\Icons\\Ability_Hunter_RunningShot",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
--		[10] = "",		
	},
	["Windwalker"] = {
		[1] = "Interface\\Icons\\ability_monk_jab", -- jab with chi count
		[2] = "Interface\\Icons\\ability_monk_tigerpalm", -- tiger palm with tiger power stacks 				
		[3] = "Interface\\Icons\\ability_monk_roundhousekick", -- blackout kick
		[4] = "Interface\\Icons\\spell_brew_dark", -- blackout kick,
		[5] = "Interface\\Icons\\monk_ability_fistoffury", -- fists of fury
		[6] = "Interface\\Icons\\ability_monk_risingsunkick", -- rising sun kick
		[7] = "",
		[8] = "",
		[9] = "",
	},
	["Brewmaster"] = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
	},
	["Combat"] = {
		-- row 1
		[1] = "Interface\\Icons\\ability_creature_cursed_02",		-- gs
		[2] = "Interface\\Icons\\Ability_Rogue_SliceDice",			-- s&d
		[3] = "Interface\\Icons\\Spell_Shadow_ShadowWordDominate",	-- ar
		-- row 2
		[4] = "Interface\\Icons\\ability_hunter_mastermarksman",	--opp
		[5] = "Interface\\Icons\\inv_misc_potiona5",				--vial
		[6] = "Interface\\Icons\\inv_weapon_rifle_01",				--bwe
		-- row 3
		[7] = "Interface\\Icons\\ability_kick",
		[8] = "",
		[9] = "",
	},
	["Assassination"] = {
		[1] = "Interface\\Icons\\Ability_Rogue_ShadowStrikes",
		[2] = "Interface\\Icons\\Ability_BackStab",
		[3] = "Interface\\Icons\\Ability_Rogue_Disembowel",
		[4] = "INTERFACE\\ICONS\\ability_rogue_deadliness",
		[5] = "Interface\\Icons\\Ability_Rogue_Rupture",
		[6] = "",
		-- row 3
		[7] = "",
		[8] = "",
		[9] = "",
		},
	["Demonology"] = {
		-- row1
		[1] = "Interface\\Icons\\spell_shadow_auraofdarkness", -- doom
		[2] = "Interface\\Icons\\spell_warlock_calldreadstalkers", -- call dreadstalkers
		[3] = "Interface\\Icons\\spell_warlock_demonicempowerment", -- demonic empowerment
		-- row2
		[4] = "Interface\\Icons\\inv_misc_gem_amethyst_02", -- sould shard
		[5] = "Interface\\Icons\\ability_warlock_handofguldan", -- HoG
		[6] = "",
		-- row3
		[7] = "",
		[8] = "Interface\\Icons\\inv_offhand_1h_artifactskulloferedar_d_01",  -- artifact
		[9] = "Interface\\Icons\\warlock_summon_doomguard",
	},
	["Affliction"] ={
		[1] = "Interface\\Icons\\Spell_Shadow_CurseOfSargeras", 		-- agony
		[2] = "Interface\\Icons\\Spell_Shadow_AbominationExplosion", 	-- corruption
		[3] = "Interface\\Icons\\spell_shadow_requiem",
		[4] = "Interface\\Icons\\Spell_Shadow_Haunting", 				-- drain soul
		[5] = "Interface\\Icons\\Spell_Shadow_UnstableAffliction_3", 	-- unstable affliction 
		[6] = "Interface\\Icons\\Ability_Warlock_Haunt",				-- haunt
		[7] = "Interface\\Icons\\warlock_summon_doomguard",				-- doom guard
		[8] = "Interface\\Icons\\warlock_grimoireofservice",
		[9] = "",
	},
	["Destruction"] = {
		[1] = "Interface\\Icons\\Spell_Fire_Immolation", 				-- Immolate
		[2] = "Interface\\Icons\\Spell_Shadow_ScourgeBuild",			-- Shadowburn
		[3] = "Interface\\Icons\\Ability_Warlock_ChaosBolt", 			-- chaos bolt
		[4] = "Interface\\Icons\\inv_misc_gem_amethyst_02", 			-- soul shard
		[5] = "Interface\\Icons\\Spell_Fire_Fireball", 					-- conflagrate
		[6] = "INTERFACE\\ICONS\\ability_warlock_baneofhavoc", 			-- havoc
		[7] = "Interface\\Icons\\warlock_summon_doomguard",				-- doom guard
		[8] = "Interface\\Icons\\warlock_grimoireofservice",			-- grimoire
		[9] = "Interface\\Icons\\spell_warlock_demonicportal_purple",   -- rift

	},
	["Shadow"] = {
		[1] = "Interface\\Icons\\Spell_Shadow_ShadowWordPain", -- Shadow Word: Pain
		[2] = "Interface\\Icons\\Spell_Holy_Stoicism", -- Vampiric Touch
		[3] = "Interface\\Icons\\Spell_Shadow_UnholyFrenzy", -- Mind Blast
		[4] = "Interface\\Icons\\Spell_Shadow_DevouringPlague", -- Devouring Plague with shadow orb count
		[5] = "INTERFACE\\ICONS\\spell_priest_mindspike", -- Mind Spike
		[6] = "Interface\\Icons\\Spell_Shadow_DemonicFortitude", -- Shadow Word: Death
		[7] = "",
		[8] = "",
		[9] = "",		
	},
	["None"] = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
		[8] = "",
		[9] = "",
--		[10] = "",		
	},
}
-------------------------------------------------------------------
-- Interface settings
-------------------------------------------------------------------
Boomkinator.options =
{
	type = "group",
	name = "Boomkinator",
	args = {
		desc = {
			type = "description",
			order = 0,
			name = L["MOVE_DESC"],
		},
		reset = {
			type = "execute",
			order = 1,
			name = L["RESET"],
			desc = L["RESET_DESC"],
			func = function() Boomkinator:Reset() end,
		},
		show = {
			type = "execute",
			order = 2,
			name = L["SHOW"],
			desc = L["SHOW_DESC"],
			func = function() Boomkinator:ShowLayout() end,
		},
		hide = {
			type = "execute",
			order = 3,
			name = L["HIDE"],
			desc = L["HIDE_DESC"],
			func = function() Boomkinator:HideLayout() end,
		},
		lock = {
			type = "execute",
			order = 4,
			name = L["LOCK"],
			desc = L["LOCK_DESC"],
			func = function() 
					settings.locked = true
					Boomkinator:LockLayout() 
				end,
		},
		unlock = {
			type = "execute",
			order = 5,
			name = L["UNLOCK"],
			desc = L["UNLOCK_DESC"],
			func = function()
					settings.locked = false
					Boomkinator:UnlockLayout()
				end,
		},
		scale = {
			type = "range",
			order = 6,
			name = L["BSC"],
			desc = L["BSC_DESC"],
			min = 0.4,
			max = 1.5,
			step = 0.05,
			get = function(info) return settings.buffscale end,
			set = function(info, val)
					settings.buffscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		fontscale = {
			type = "range",
			order = 7,
			name = "Font Scale",
			desc = "Scale of timer fonts", 
			min = 8,
			max = 14,
			step = 1,
			get = function(info) return settings.fontscale end,
			set = function(info, val)
					settings.fontscale = val
					Boomkinator:UpdateLayout()
				end,
		}
	},
}
-------------------------------------------------------------------
-- Default Settings
-------------------------------------------------------------------
Boomkinator.defaults = {
	profile = {
		buffscale = 0.9,
		fontscale = 10,
		locked = false,
		disabled = false,
	}
}
-------------------------------------------------------------------
-- Ace Framework Events
-------------------------------------------------------------------
function Boomkinator:OnInitialize()
	--self:Print("OnInitialize")
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99"..Boomkinator.Credits1.."|r")
	self.db = LibStub("AceDB-3.0"):New("BoomkinatorDB", Boomkinator.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	settings = self.db.profile
	Boomkinator.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Boomkinator", Boomkinator.options, "boom")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Boomkinator", "Boomkinator")

	self:UpdateLayout()
end

function Boomkinator:OnProfileChanged()
	--self:Print("OnProfileChanged")
	settings = self.db.profile
	self:UpdateLayout()
end

function Boomkinator:OnEnable()
	--self:Print("OnEnable")
	settings.disabled = false
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:UpdateLayout()
end

function Boomkinator:OnDisable()
	--self:Print("OnDisable")
	-- events
	settings.disabled = true
	self:UpdateLayout()
end

function Boomkinator:MediaUpdate()

end
-------------------------------------------------------------------
-- Service Functions
-------------------------------------------------------------------
function Boomkinator:FormatTime(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	local mins = floor(time / 60)
	local secs = time - (mins * 60)
	return sformat("%d:%02d", mins, secs)
end

function Boomkinator:FormatShort(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	return sformat("%0.1f", time)
end
-------------------------------------------------------------------
-- Command Prompt Response
-------------------------------------------------------------------
function Boomkinator:Reset()
	local h = _G["BoomkinatorFrame"]
	h:ClearAllPoints()
	h:SetPoint("CENTER", "UIParent", "CENTER", 0, 0)
	--self:UpdateLayout()
end

-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

-------------------------------------------------------------------
-- External Event Handling
------------------------------------------------------------------
function Boomkinator:PLAYER_REGEN_ENABLED()
	--self:Print("Regen Enabled")
	self:CancelTimer(self.UpdateTimer, true)
	self:HideLayout()
end

function Boomkinator:PLAYER_REGEN_DISABLED()
	--self:Print("Regen Disabled")

	if updater == "" then
		--self:Print("Entered combat without settings, trying to fix UI")
		self:UpdateLayout()
	end
	
	if updater ~= "" then
		--self:Print(updater)
		self.UpdateTimer = self:ScheduleRepeatingTimer(updater, 0.1)
		self:ShowLayout()
	end
end

function Boomkinator:ACTIVE_TALENT_GROUP_CHANGED()
	--self:Print("Talents Changed")
	self:UpdateLayout()
end

function Boomkinator:CheckTalents()
	local _, class = UnitClass("player")
	
	-- druid
	if class == "DRUID" and GetSpecialization() == 1 then -- moonkin
		updater = "ButtonsOwlUpdate"
    --elseif (class == "DRUID") and GetSpecialization() == 2 then -- cat
	--	updater = "ButtonsCatUpdate"
    --elseif (class == "DRUID") and GetSpecialization() == 3 then -- bear
	--	updater = "ButtonsBearUpdate"		
	-- hunter
    --elseif class == "HUNTER" and GetSpecialization() == 1 then -- BeastMaster
	--	updater = "ButtonsHunterBeastUpdate"		
    --elseif class == "HUNTER" and GetSpecialization() == 3 then -- survival
	--	updater = "ButtonsHunterSurvivalUpdate"
	-- monk
	--elseif class == "MONK" and GetSpecialization() == 1 then -- monk brewmaster
	--	updater = "ButtonsBrewmasterUpdate"
	--elseif class == "MONK" and GetSpecialization() == 3 then -- monk windwalker
	--	updater = "ButtonsWindwalkerUpdate"
	-- rogue
	--elseif class == "ROGUE" and  GetSpecialization() == 1 then -- rogue assassin
	--	updater = "ButtonsAssassinationUpdate"
	elseif class == "ROGUE" and  GetSpecialization() == 2 then -- rogue combat
		updater = "ButtonsCombatUpdate"
	-- warlock
	elseif class == "WARLOCK" and GetSpecialization() == 1 then -- affliction
		updater = "ButtonsAfflictionUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 2 then -- demonology
		updater = "ButtonsDemonologyUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 3 then -- destruction
		updater = "ButtonsDestructUpdate"		
	-- priest
	--elseif class == "PRIEST" and GetSpecialization() == 3 then -- shadow priest
	--	updater = "ButtonsShadowUpdate"
	else
		updater = ""
	end
	--self:Print("CheckTalents = ".. updater)
end
-------------------------------------------------------------------
-- Buff UI
-------------------------------------------------------------------
function Boomkinator:UpdateLayout()
	--self:Print("Update Layout")
	local icons, spec
	local spellName, spellIcon, spellSelected
	
	self:CheckTalents()
	if updater == "ButtonsOwlUpdate" then
		spec = GetSpecialization()
		
		icons = Boomkinator.Icons["Owl"]
		-- treants
		--_, spellName, spellIcon, spellSelected, _ = GetTalentInfo(1, 1, 1)
		--if spellSelected then 
		--	icons[7] = spellIcon
		--	Boomkinator.OwlSpells[9] = spellName -- treants
		--else
		--	icons[7] = nil
		--	Boomkinator.OwlSpells[9] = nil
		--end
		-- alignments vs incarnation
		_, spellName, spellIcon, spellSelected, _ = GetTalentInfo(5, 2, 1)
		if spellSelected then 
			icons[8] = spellIcon
			Boomkinator.OwlSpells[8] = spellName -- incarnation
		else
			icons[8] = icons[12]
			Boomkinator.OwlSpells[8] = GetSpellInfo(194223) -- alignment
		end
		-- flare
		_, spellName, spellIcon, spellSelected, _ = GetTalentInfo(5, 3, 1)
		if spellSelected then 
			icons[2] = spellIcon
			Boomkinator.OwlSpells[14] = spellName -- stellar flare
		else
			icons[2] = nil
			Boomkinator.OwlSpells[14] = nil
		end
		
	elseif updater == "ButtonsCatUpdate" then
		icons = Boomkinator.Icons["Cat"]
	elseif updater == "ButtonsBearUpdate" then
		icons = Boomkinator.Icons["Bear"]		
	elseif updater == "ButtonsHunterSurvivalUpdate" then
		icons = Boomkinator.Icons["HunterSurvival"]
	elseif updater == "ButtonsHunterBeastUpdate" then
		icons = Boomkinator.Icons["HunterBeast"]
	elseif updater == "ButtonsBrewmasterUpdate" then
		icons = Boomkinator.Icons["Brewmaster"]
	elseif updater == "ButtonsWindwalkerUpdate" then
		icons = Boomkinator.Icons["Windwalker"]
	elseif updater == "ButtonsCombatUpdate" then
		icons = Boomkinator.Icons["Combat"]
	elseif updater == "ButtonsAssassinationUpdate" then
		icons = Boomkinator.Icons["Assassination"]
	elseif updater == "ButtonsAfflictionUpdate" then
		icons = Boomkinator.Icons["Affliction"]		
	elseif updater == "ButtonsDemonologyUpdate" then
		icons = Boomkinator.Icons["Demonology"]
	elseif updater == "ButtonsDestructUpdate" then
		icons = Boomkinator.Icons["Destruction"]
		 _, spellName, spellIcon, spellSelected, _ = GetTalentInfo(7, 1, 1)
		if spellSelected then
			wreak = 1
		else
			wreak = 0
		end
	elseif updater == "ButtonsShadowUpdate" then
		icons = Boomkinator.Icons["Shadow"]
	else
		icons = Boomkinator.Icons["None"]
	end

	if updater ~= nil then
		bframe = _G["BoomkinatorFrame"]

		ccount = _G["BoomkinatorFrameCCount"]
		ccount:SetText("")

		for i = 1, 9 do
			buttons[i] = _G["BoomkinatorFrameButton"..i]
			buttons[i]:SetTexture(icons[i])
			buttons[i]:SetVertexColor(1, 1, 1, 1)
			timers[i]  = _G["BoomkinatorFrameTime"..i]
			timers[i]:SetText("")
			timers[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
			stacks[i]  = _G["BoomkinatorFrameStack"..i]
			stacks[i]:SetText("")
			stacks[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
		end
	end

	BoomkinatorFrame:SetScale(settings.buffscale)
	self:HideLayout()

	if settings.locked then
		Boomkinator:LockLayout()
	else
		Boomkinator:UnlockLayout()
	end
end

function Boomkinator:ShowLayout()
	bframe:Show()
end

function Boomkinator:HideLayout()
	bframe:Hide()
end

function Boomkinator:LockLayout()
	bframe:EnableMouse(false)
end

function Boomkinator:UnlockLayout()
	bframe:EnableMouse(true)
end

function Boomkinator:GetSeverityColor(percent)
	if (percent >= 0.5) then
		return (1.0-percent)*2, 1.0, 0.0
	else
		return 1.0, percent*2, 0.0
	end
end

-------------------------------------------------------------------
-- Class Functionality: Warlock Affliction
-------------------------------------------------------------------
function Boomkinator:ButtonsAfflictionUpdate()
    local expire
	local spellName, spellIcon
	local combos, meta
		
	combos = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	
	if combos == 0 then
		stacks[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 1)	
	else
		stacks[5]:SetText("x"..combos)
		buttons[5]:SetVertexColor(1, 1, 1, 1)	
	end
	
	if UnitExists("target") then
		--check agony
		spellName = Boomkinator.AffSpells[1]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end			

		--check corruption
		spellName = Boomkinator.AffSpells[2]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end			
		
		-- siphon
		spellName = Boomkinator.AffSpells[4]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		end	
		
		--check affliction
		spellName = Boomkinator.AffSpells[3]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		end	
		
--		--check haunt
--		spellName = Boomkinator.AffSpells[5]
--		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
--		
--		if buffExpire then
--			expire = buffExpire - GetTime()
--			timers[5]:SetText(Boomkinator:FormatShort(expire))
--			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
--		else
--			timers[5]:SetText("")
--			buttons[5]:SetVertexColor(1, 1, 1, 1)
--		end	
		
	end
	
	local start, duration

	-- dark soul
--	spellName = Boomkinator.AffSpells[6]
--	start, duration = GetSpellCooldown(spellName)
--	if start then
--		if start == 0 or (start > 0 and duration < 1.5 ) then
--			timers[6]:SetText("")
--			buttons[6]:SetVertexColor(1, 1, 1, 1)
--		else
--			-- on cooldown
--			expire = start + duration - GetTime()
--			timers[6]:SetText(Boomkinator:FormatTime(expire))
--			buttons[6]:SetVertexColor(1, 1, 1, 0.5)
--		end
--	else
--		timers[6]:SetText("NA")
--		buttons[6]:SetVertexColor(1, 1, 1, 0.3)	
--	end

	-- doomguard
	spellName = Boomkinator.AffSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
	
		-- grimoire
	spellName = Boomkinator.AffSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Demonology
-------------------------------------------------------------------
function Boomkinator:ButtonsDemonologyUpdate()
    local expire
	local spellName, spellIcon
	local shards
	-- regular cooldowns
	local start, duration
	local buffName, buffDuration, buffExpire
	local haveTotem, name, startTime, duration, icon -- summonable stuff
	local stalkers = 0
	local imps = 0
	local tsum = ""
	local ind = {
		["imps"] = {
			[0] = "",
			[1] = "I",
			[2] = "II",
			[3] = "III",
			[4] = "IIII",
			},
		["stalkers"] = {
			[0] = "",
			[1] = "S",
			[2] = "SS",
			[3] = "SSS",
			[4] = "SSSS",
			}
		}
	
	for i=1, MAX_TOTEMS do
		haveTotem, name, startTime, duration, icon = GetTotemInfo(i);
		if haveTotem then
			if name == "Wild Imps" then
				imps = imps + 1
			elseif name == "Dreadstalkers" then
				stalkers = stalkers + 1
			end
		end
	end
	if imps > 0 then
		tsum = tsum .. ind["imps"][imps]
	end
	if stalkers > 0 then
		tsum = tsum .. ind["stalkers"][stalkers]
	end
	stacks[8]:SetText(tsum)
		
	shards = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	stacks[5]:SetText("x"..shards)
	if shards >= 3 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	elseif shards >= 2 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)	
	end
	buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	
	if UnitExists("target") then
		--check doom
		spellName = Boomkinator.DemoSpells[1]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		end			
	end
	
	if UnitExists("pet") then
		-- check demonic empowerment
		spellName = Boomkinator.DemoSpells[3]
		buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("pet", spellName)
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 0.75)
		end	
	end
	
	local start, duration
		
	-- demonic calling
	spellName = Boomkinator.DemoSpells[6]
	buffName, _, _, _, _, _, _ = UnitBuff("player", spellName)
	-- call dreadstalkers	
	if shards >= 2 or buffName then
		spellName = Boomkinator.DemoSpells[2]
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[2]:SetText("")
				buttons[2]:SetVertexColor(1, 1, 1, 0.75)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[2]:SetText(Boomkinator:FormatTime(expire))
				buttons[2]:SetVertexColor(1, 1, 1, 0.25)
			end
		else
			timers[2]:SetText("NA")
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)	
		end
	else
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 0.25)
	end

	-- artifact
	spellName = Boomkinator.DemoSpells[4]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- custom pet actions
	spellName = GetSpellInfo(119898) -- command demon
	spellIcon = GetSpellTexture(spellName)
	buttons[6]:SetTexture(spellIcon)
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatTime(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- doomguard
	spellName = Boomkinator.DemoSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[9]:SetText("")
			buttons[9]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[9]:SetText(Boomkinator:FormatTime(expire))
			buttons[9]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[9]:SetText("NA")
		buttons[9]:SetVertexColor(1, 1, 1, 0.25)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Destruction
-------------------------------------------------------------------
function Boomkinator:ButtonsDestructUpdate()
    local expire
	local spellName, spellIcon
	local shards
	-- regular cooldowns
	local start, duration

	shards = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	
	stacks[4]:SetText("x"..shards)
	
	if shards < 2 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	elseif shards < 4 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[4]:SetVertexColor(1, 1, 1, 0.25)	
	end

	if UnitExists("target") then
		--check immolate
		spellName = Boomkinator.DestSpells[1]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		end			

		-- check eradicate
		spellName = Boomkinator.DestSpells[11]
		_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
		else
			timers[3]:SetText("")
		end
		
		
		-- shadowburn
		if UnitHealth("target")/UnitHealthMax("target") < 0.2 and shards >= 1  then
			buttons[2]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- hold shadowburn
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		-- conflag
		spellName = Boomkinator.DestSpells[2]
		buffCount, _, _, _ = GetSpellCharges(spellName)
		stacks[5]:SetText("x" .. buffCount)
		if buffCount == 2 and shards < 4 then
			buttons[5]:SetVertexColor(1, 1, 1, 0.75)
		elseif buffCount == 1 and shards < 5 then
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)			
		else
			buttons[5]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		-- rift
		spellName = Boomkinator.DestSpells[4]
		buffCount, _, _, _ = GetSpellCharges(spellName)
				
		if buffCount and buffCount > 0 then
			stacks[9]:SetText("x" .. buffCount)
			timers[9]:SetText("")
		else
			stacks[9]:SetText("")
		end
		
		if buffCount == 3 then
			buttons[9]:SetVertexColor(1, 1, 1, 1)
		elseif buffCount == 2 then
			buttons[9]:SetVertexColor(1, 1, 1, 0.75)			
		elseif buffCount == 1 then			
			buttons[9]:SetVertexColor(1, 1, 1, 0.50)
		else
			buttons[9]:SetVertexColor(1, 1, 1, 0.25)
			
		--check cooldown for next
			start, duration = GetSpellCooldown(spellName)
			if start then
				if start == 0 or (start > 0 and duration < 1.5 ) then
					timers[9]:SetText("")
				else
					expire = start + duration - GetTime()
					timers[9]:SetText(Boomkinator:FormatTime(expire))
				end
			end
		end
		
		-- chaos bolt
		if shards >= 2 then
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		else
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
		
	-- Havoc
	if wreak == 0 then -- on cooldown
		spellName = Boomkinator.DestSpells[9]
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 1)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[6]:SetText(Boomkinator:FormatTime(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.5)
			end
		else
			timers[6]:SetText("NA")
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		-- debuff on focus
		if UnitExists("focus") then
			spellName = Boomkinator.DestSpells[9]
			_, _, spellIcon, _, _, buffDuration, buffExpire = UnitDebuff("focus", spellName, nil, "PLAYER")
		
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[6]:SetText(Boomkinator:FormatShort(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.25)
			else
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 0.75)
			end			
		end
	end
		
	-- doomguard
	spellName = Boomkinator.DestSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- doomguard
	spellName = Boomkinator.DestSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Rogue Combat
-------------------------------------------------------------------
function Boomkinator:ButtonsCombatUpdate()
    local expire
	local spellName, spellIcon
	local combos
	local start, duration
	
	combos = UnitPower("player", 4) -- combo points

	if combos > 0 then
		stacks[2]:SetText("x" .. combos)
	else
		stacks[2]:SetText("")
	end
		
	if UnitExists("target") then
		-- ghost strike
		spellName = Boomkinator.CombatSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 0.75)
		end
	end
	
	-- self buffs
	-- slice and dice
	spellName = Boomkinator.CombatSpells[2]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[2]:SetText(Boomkinator:FormatShort(expire))
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	else
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 0.75)
	end

	-- opportiunity
	spellName = Boomkinator.CombatSpells[4]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	else
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end
		
	-- check cooldowns
	-- rush
	spellName = Boomkinator.CombatSpells[3]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[3]:SetText(Boomkinator:FormatTime(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[3]:SetText("NA")
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- vial
	spellName = Boomkinator.CombatSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatTime(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[5]:SetText("NA")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- shot
	spellName = Boomkinator.CombatSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatTime(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- kick
	spellName = Boomkinator.CombatSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
end
-------------------------------------------------------------------
-- Class Functionality: Rogue Assassination
-------------------------------------------------------------------
function Boomkinator:ButtonsAssassinationUpdate()
    local expire
	local spellName, spellIcon
	local combos
	
	if UnitExists("target") then
		combos = GetComboPoints("player", "targer")
		
		-- anticipation
		spellName = Boomkinator.AssassinationSpells[7]
		buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
		if buffName and buffCount then
			combos = combos + buffCount
		end
		
		if combos > 0 then
			stacks[6]:SetText("x" .. combos)
		else
			stacks[6]:SetText("")
		end
	
		-- check debuffs
		-- rupture
		spellName = Boomkinator.AssassinationSpells[5]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.5)
		else
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- self buffs
	
	-- blindside / stabbing time
	spellName = Boomkinator.AssassinationSpells[6]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire or UnitHealth("target")/UnitHealthMax("target") < 0.35 then
		buttons[2]:SetVertexColor(1, 1, 1, 1)
	else
		buttons[2]:SetVertexColor(1, 1, 1, 0.5)
	end
	
	-- envenom
	spellName = Boomkinator.AssassinationSpells[3]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[3]:SetText(Boomkinator:FormatShort(expire))
		buttons[3]:SetVertexColor(1, 1, 1, 0.5)
	else
		timers[3]:SetText("")
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	end
	
	-- check cooldowns
	local start, duration
	-- ks
	spellName = Boomkinator.AssassinationSpells[4]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[4]:SetText(Boomkinator:FormatTime(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.5)
		end
	else
		timers[4]:SetText("NA")
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end
	
end
-------------------------------------------------------------------
-- Class Functionality: Monk Windwalker
-------------------------------------------------------------------
function Boomkinator:ButtonsWindwalkerUpdate()
    local expire
	local spellName, spellIcon --, buffName, buffCount, buffDuration, buffExpire
	local chi, comboT, comboK
	
	-- self buffs
	chi = UnitPower("player" , 12) -- SPELL_POWER_LIGHT_FORCE
	if chi == 0 then
		stacks[1]:SetText("")
	else
		stacks[1]:SetText("x" .. chi)
	end
	buttons[1]:SetVertexColor(1, 1, 1, 0.7)	

	-- tiger power
	spellName = Boomkinator.WindwalkerSpells[1]
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[2]:SetText("x" .. buffCount)
		timers[2]:SetText(Boomkinator:FormatShort(expire))
	else
		stacks[2]:SetText("x0")
		timers[2]:SetText("")
	end
	
	-- combo breaker: tiger palm
	spellName = Boomkinator.WindwalkerSpells[2]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if (buffName and buffExpire) or chi > 0 then
		-- highlight palm
		buttons[2]:SetVertexColor(1, 1, 1, 0.7)
	else
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- combo breaker: blackout kick
	spellName = Boomkinator.WindwalkerSpells[3]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if (buffName and buffExpire) or chi > 1 then
		-- highlight kick
		buttons[3]:SetVertexColor(1, 1, 1, 0.7)
	else
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- tigereye brew
	spellName = Boomkinator.WindwalkerSpells[4]
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[4]:SetText("x" .. buffCount)
		timers[4]:SetText(Boomkinator:FormatTime(expire))
	else
		stacks[4]:SetText("x0")
		timers[4]:SetText("")
	end
		
	-- cooldowns
	local start, duration
	--fists of fury
	spellName = Boomkinator.WindwalkerSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if (start == 0 or (start > 0 and duration < 1.5 )) and chi > 2 then
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 0.7)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[5]:SetText("NA")
		buttons[5]:SetVertexColor(1, 1, 1, 0.7)
	end

	--rising sun kick
	spellName = Boomkinator.WindwalkerSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if (start == 0 or (start > 0 and duration < 1.5 )) and chi > 1 then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.7)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatShort(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
end
-------------------------------------------------------------------
-- Class Functionality: Monk Brewmaster
-------------------------------------------------------------------
function Boomkinator:ButtonsBrewmasterUpdate()

end
-------------------------------------------------------------------
-- Class Functionality: Druid Cat
-------------------------------------------------------------------
function Boomkinator:ButtonsCatUpdate()
	local expire
	local spellName, spellIcon
	local combos
	
	-- predatory swiftness
	spellName = Boomkinator.CatSpells[3]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[3]:SetText(Boomkinator:FormatShort(expire))
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	else
		timers[3]:SetText("")
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- self buffs: savage roar
	spellName = Boomkinator.CatSpells[5]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	else
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	end
		
	-- target debuffs
	if UnitExists("target") then
		-- check combo points
		combos = GetComboPoints("player", "target")
	
		if combos > 0 then
			stacks[1]:SetText("x" .. combos)
		else
			stacks[1]:SetText("")
		end
	
		-- rip
		spellName = Boomkinator.CatSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
	
		-- rake
		spellName = Boomkinator.CatSpells[4]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration, berserk

	spellName = Boomkinator.CatSpells[6]
	-- check active berserk
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		berserk = 1
	else 
		berserk = 0
	end
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- tiger's fury	
	spellName =  Boomkinator.CatSpells[7]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			if berserk == 0 then
				buttons[6]:SetVertexColor(1, 1, 1, 1)
			else -- blocked
				buttons[6]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatShort(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
end
-------------------------------------------------------------------
-- Class Functionality: Druid Bear
-------------------------------------------------------------------
function Boomkinator:ButtonsBearUpdate()

	-- target debuffs
	if UnitExists("target") then
		-- thrash
		spellName = Boomkinator.BearSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end
	
		-- lacerate
		spellName = Boomkinator.BearSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
		
		-- faerie fire
		spellName = Boomkinator.BearSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatTime(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		end
		
	end
	
	-- check cooldown
	local start, duration, berserk

	-- mangle
	spellName = Boomkinator.BearSpells[4]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[4]:SetText("NA")
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- surv instinct
	spellName = Boomkinator.BearSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatTime(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[5]:SetText("NA")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- berserk
	spellName = Boomkinator.BearSpells[6]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[6]:SetText(Boomkinator:FormatTime(expire))
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[6]:SetText("NA")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- barkskin
	spellName = Boomkinator.BearSpells[7]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[7]:SetText("")
			buttons[7]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[7]:SetText(Boomkinator:FormatTime(expire))
			buttons[7]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[7]:SetText("NA")
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- special
	--savage defense
	spellName = Boomkinator.BearSpells[8]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[8]:SetText(Boomkinator:FormatShort(expire))
	else
		timers[8]:SetText("")
	end
	
	local rage = UnitPower("player" , 1)  -- rage
	if rage >= 60 then
		buttons[8]:SetVertexColor(1, 1, 1, 1)
	else
		buttons[8]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	
end
-------------------------------------------------------------------
-- Class Functionality: Druid Moonkin
-------------------------------------------------------------------
function Boomkinator:ButtonsOwlUpdate()
	local spellName, spellIcon
	local buffName, buffDuration, buffExpire, buffCount
	local start, duration, expire
	
	local power = UnitPower("player", SPELL_POWER_ECLIPSE)
		
	if power > 0 then -- solar
		stacks[5]:SetText(power)
	else
		stacks[5]:SetText("")
	end
	
	-- starfall
	if power >= 60 then
		buttons[7]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[7]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- starsurge
	if power >= 40 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- lunar empowerment
	spellName = Boomkinator.OwlSpells[12]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stacks[4]:SetText("X")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	else
		stacks[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- solar empowerment
	spellName = Boomkinator.OwlSpells[13]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stacks[6]:SetText("X")
		buttons[6]:SetVertexColor(1, 1, 1, 1)
	else
		stacks[6]:SetText("")
		buttons[6]:SetVertexColor(1, 1, 1, 0.5)
	end

	-- new moon
	spellName = Boomkinator.OwlSpells[7]
	-- dynamic icon
	spellIcon = GetSpellTexture(spellName)
	buttons[9]:SetTexture(spellIcon)
	-- charges
	buffCount, _, _, _ = GetSpellCharges(spellName)
	if buffCount and buffCount > 0 then
        stacks[9]:SetText("x" .. buffCount)
        timers[9]:SetText("")
	end
	if buffCount and buffCount > 0 then
		buttons[9]:SetVertexColor(1, 1, 1, 0.75)
	else
        buttons[9]:SetVertexColor(1, 1, 1, 0.25)

		--check cooldown for next
        start, duration = GetSpellCooldown(spellName)
        if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[9]:SetText("")
            else
				expire = start + duration - GetTime()
                timers[9]:SetText(Boomkinator:FormatTime(expire))
            end
        end
	end

	if UnitExists("target") then
		-- checking for debuffs on the target
		-- moonfire
		spellName = Boomkinator.OwlSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end
		-- sunfire
		spellName = Boomkinator.OwlSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		end
		--spellflare
		spellName = Boomkinator.OwlSpells[14]
		if spellName and power >= 15 then
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.25)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
		end
	end

	-- treants
	spellName = Boomkinator.OwlSpells[9]
	if spellName then
		start, duration = GetSpellCooldown(spellName)
		if start then -- has treants
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[7]:SetText("")
				buttons[7]:SetVertexColor(1, 1, 1, 1)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[7]:SetText(Boomkinator:FormatTime(expire))
				buttons[7]:SetVertexColor(1, 1, 1, 0.25)
			end
		else
			timers[7]:SetText("NA")
			buttons[7]:SetVertexColor(1, 1, 1, 0.25)
		end
	end
	
	-- alignment
	spellName = Boomkinator.OwlSpells[8]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[8]:SetText("")
			buttons[8]:SetVertexColor(1, 1, 1, 0.75)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[8]:SetText(Boomkinator:FormatTime(expire))
			buttons[8]:SetVertexColor(1, 1, 1, 0.25)
		end
	else
		timers[8]:SetText("NA")
		buttons[8]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- HotW
	--spellName = Boomkinator.OwlSpells[9]
	--start, duration = GetSpellCooldown(spellName)
	--if start then
	--	if start == 0 or (start > 0 and duration < 1.5 ) then
	--		timers[9]:SetText("")
	--		buttons[9]:SetVertexColor(1, 1, 1, 1)
	--	else
	--		-- on cooldown
	--		expire = start + duration - GetTime()
	--		timers[9]:SetText(Boomkinator:FormatTime(expire))
	--		buttons[9]:SetVertexColor(1, 1, 1, 0.3)
	--	end
	--else
	--	timers[9]:SetText("NA")
	--	buttons[9]:SetVertexColor(1, 1, 1, 0.3)
	--end
		
end
-------------------------------------------------------------------
-- Class Functionality: Hunter
-------------------------------------------------------------------
function Boomkinator:ButtonsHunterSurvivalUpdate()
	local expire
	local spellName, spellIcon
		
	-- target debuffs
	if UnitExists("target") then
		-- Serpent Sting
		spellName = Boomkinator.SurvivalSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration

	-- Explovive Shot	
	spellName =  Boomkinator.SurvivalSpells[1]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[1]:SetText("NA")
		buttons[1]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- Black Arrow	
	spellName =  Boomkinator.SurvivalSpells[2]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[2]:SetText("NA")
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	--Kill Shot
	spellname = Boomkinator.SurvivalSpells[4]
	if UnitHealth("target")/UnitHealthMax("target") > 0.2 then 
		-- too soon
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	else
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				-- ready
				timers[5]:SetText("")
				buttons[5]:SetVertexColor(1, 1, 1, 1)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[5]:SetText(Boomkinator:FormatTime(expire))
				buttons[5]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			timers[5]:SetText("NA")
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
end

function Boomkinator:ButtonsHunterBeastUpdate()
	local expire
	local spellName, spellIcon
		
	-- target debuffs
	if UnitExists("target") then
		-- Serpent Sting
		spellName = Boomkinator.SurvivalSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration

	spellName =  Boomkinator.BeastSpells[1]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[1]:SetText("NA")
		buttons[1]:SetVertexColor(1, 1, 1, 0.3)
	end

	spellName =  Boomkinator.BeastSpells[2]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[2]:SetText("NA")
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	spellName =  Boomkinator.BeastSpells[3]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[3]:SetText("NA")
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end

	spellName =  Boomkinator.BeastSpells[4]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[4]:SetText("NA")
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	spellName =  Boomkinator.BeastSpells[5]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[5]:SetText("NA")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end
end

-----------------------------------------------------------------
-- Class Functionality: Shadow Priest
-----------------------------------------------------------------
function Boomkinator:ButtonsShadowUpdate()
	local expire
	local spellName, spellIcon
	local orbs
	
	-- self buffs
	orbs = UnitPower("player" , 13) -- SPELL_POWER_SHADOW_ORBS
	
	if orbs == 0 then
		stacks[4]:SetText("")
	else
		stacks[4]:SetText("x" .. orbs)
	end
		
	-- Shadow Word:Pain
	if UnitExists("target") then
			spellName = Boomkinator.ShadowSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- Vampiric Touch
	if UnitExists("target") then
		spellName = Boomkinator.ShadowSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- Mind Blast
	spellName =  Boomkinator.ShadowSpells[3]
	start, duration = GetSpellCooldown(spellName)
	if start then
		if start == 0 or (start > 0 and duration < 1.5 ) then
			-- ready
			timers[3]:SetText("")
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		else
			-- on cooldown
			expire = start + duration - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
		timers[3]:SetText("NA")
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)	
	end
	
	-- Devouring Plague
	spellName = Boomkinator.ShadowSpells[4]
	if orbs == 0 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	elseif orbs == 1 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	elseif orbs == 2 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.7)
	elseif orbs == 3 then
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	end
	
	-- Surge of Darkness (can have two stacks of this buff)
	spellName = Boomkinator.ShadowSpells[5]
	buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		stacks[5]:SetText("x" .. buffCount)
		buttons[5]:SetVertexColor(1, 1, 1, 1)
		timers[5]:SetText(Boomkinator:FormatShort(expire))
	else
		stacks[5]:SetText("x0")
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- Shadow Word: Death
	spellName = Boomkinator.ShadowSpells[6]
	if UnitHealth("target")/UnitHealthMax("target") > 0.2 then 
		-- too soon
		timers[6]:SetText("")
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	else
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				-- ready
				timers[6]:SetText("")
				buttons[6]:SetVertexColor(1, 1, 1, 1)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				timers[6]:SetText(Boomkinator:FormatShort(expire))
				buttons[6]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			timers[6]:SetText("NA")
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
end